C	Copyright 2002, Leon Kos, University of Ljubljana	

	subroutine display
	implicit none
	include 'GL/fgl.h'
	common /quaternion/ last(4), cur(4)
	real last, cur, m(4,4)
	call build_rotmatrix(m, cur)
	call fglLoadIdentity
	call fglMultMatrixf(m)
	call fglclear(GL_COLOR_BUFFER_BIT+GL_DEPTH_BUFFER_BIT)
	call fglutSolidTeapot(dble(0.5))
	call fglutSwapBuffers
	end


	subroutine motion (x, y) 
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	implicit none
	integer x, y
	common /quaternion/ last(4), cur(4)
	common /mousestart/ beginx, beginy
	common /viewport/ width, height
	integer width, height
	integer beginx, beginy
	real last, cur
	real p1x, p1y, p2x, p2y
	p1x = (2.0*beginx - width)/width
	p1y = (height - 2.0*beginy)/height
	p2x = (2.0 * x - width) / width
	p2y = (height - 2.0 * y) / height
	call trackball(last,p1x, p1y, p2x, p2y)
	call add_quats(last, cur, cur)
	beginx = x
	beginy = y
	call fglutPostRedisplay
	end

	subroutine mouse (button, state, x, y) 
	implicit none
	integer button, state, x, y
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	include 'GL/fglu.h'
	common /mousestart/ beginx, beginy
	integer beginx, beginy
	beginx = x
	beginy = y	
	end

	subroutine reshape(w, h)
	include 'GL/fgl.h'
	integer w, h
	real*8 l
	common /viewport/ width, height
	integer width, height
	width=w
	height=h
	l = 1
	call fglViewPort(0, 0, w, h)
	call fglMatrixMode(GL_PROJECTION)
	call fglLoadIdentity
	call fglOrtho(-l,l,-l,l,-l,l)
	call fglMatrixMode(GL_MODELVIEW)
	call fglLoadIdentity
	end
	

	program trackballdemo
	implicit none
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	include 'GL/fglu.h'
	external display
	external motion
	external mouse
	external reshape
	integer window
	common /quaternion/ last(4), cur(4)
	real last, cur
	call trackball(cur, 0.0, 0.0, 0.0, 0.0)
	call fglutinit
	call fglutinitdisplaymode(GLUT_DOUBLE+GLUT_RGB+GLUT_DEPTH)
	window = fglutcreatewindow('Use mouse to rotate')
	call fglutdisplayfunc(display)
	call fglutmousefunc(mouse)
	call fglutmotionfunc(motion)
	call fglutreshapefunc(reshape)
	call fglEnable(GL_LIGHTING)
	call fglEnable(GL_LIGHT0)
	call fglEnable(GL_DEPTH_TEST)
	call fglutmainloop
	end
